LISP Geo-Coordinate Use-Cases
Dino Farinacci
lispers.net
San Jose
CA
USA
farinacci@gmail.com
This document describes how Geo-Coordinates can be used in the LISP Architecture and Protocols. The functionality proposes a new LISP Canonical Address Format (LCAF) encoding for such Geo-Coordinates, which is compatible with the Global Positioning Satellite (GPS) encodings used by other routing protocols.
This document updates [RFC8060].

Introduction
The LISP architecture and protocols [RFC9300] introduce two new namespaces, Endpoint Identifiers (EIDs) and Routing Locators (RLOCs) which are intended to separate the semantics of identity and topological location from an IP address. To provide flexibility for current and future applications, these values can be encoded in LISP control messages using a general syntax that includes Address Family Identifier (AFI) [RFC1700].
This document proposes a new LCAF encoding for Geo-Coordinates, which is compatible with the one used in other routing protocols, namely OSPF [I-D.acee-ospf-geo-location], IS-IS [I-D.shen-isis-geo-coordinates], and BGP [I-D.chen-idr-geo-coordinates] protocols
This document updates [RFC8060]. In particular, the use of Geo-Coordinates encoding defined in Section 4.3 of [RFC8060] and identified by LCAF type 5 is deprecated. The LCAF type defined in this document is called "Geo-Location" with a new LCAF type allocated.
The Geo-Coordinates LCAF type is used in EID-records and RLOC-records. See [RFC9301] for what LISP messages contain EID-records and RLOC-records.

Requirements Notation
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD”, "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Definition of Terms
Geo-Point: is a Geo-Coordinate according to [GEO] that defines a point from parameters Latitude, Longitude, and Altitude.
Geo-Prefix: forms a circle of a geographic area made up of a Geo-Point and a Radius. A Geo-Point is known to be "more-specific" than a Geo-Prefix when its physical location is within the geographic circle.

Relevant Use Cases

Geo-Points in RLOC-records
Geo-Points can accompany an RLOC-record to determine the physical location of an ETR or RTR. This can aid in determining geographical distance when topological distance is inaccurate or hidden. When Geo-Points are encoded in RLOC-records with RLOC addresses the LCAF AFI-List Type should be used.
Geo-Points can be used as the sole piece of information in an RLOC-record when an EID maps to a Geo-Coordinate. If it is desirable to find the geographical location of any EID, this method can be convenient.
Here is a high-level use-case where an EID can map to a Geo- Coordinate RLOC. Lets say that an EID is assigned to a physical shipping package by a package delivery company. And the EID is encoded as an IPv6 address where the tracking number is embedded in an IPv6 EID. The network has LISP nodes deployed in many locations that are configured with their respective Geo-Coordinates. As the package roams, the LISP node that discovers the EID, registers it to the LISP mapping system. The EID-to-RLOC mapping is EID=IPv6 and RLOC=Geo-Coordinate. If someone does a mapping database lookup on the IPv6 EID, what is returned is the Geo-Coordinate. As the EID roams, new registrations with different Geo-Coordinates are stored, allowing the physical tracking of the package.
The encoding format is consistent with the encoding used in other routing protocols, namely OSPF [I-D.acee-ospf-geo-location], IS-IS [I-D.shen-isis-geo-coordinates], and BGP [I-D.chen-idr-geo-coordinates].

Geo-Prefixes in EID-records and RLOC-records
A Geo-Prefix is defined to be a Geo-Coordinate point and a Radius. This allows a circle to be drawn on a geographic map. The Geo-Prefix can describe a coarse physical location for an RLOC when encoded in an RLOC-record. So an RLOC could be registered in the mapping database indicating it is in a city or country versus the exact location where a Geo-Point would locate it.
A Geo-Prefix could allow a Distinguished-Name [I-D.ietf-lisp-name-encoding] to be registered as an EID with an RLOC that contains a Geo-Prefix. For example EID="San Francisco", with RLOC=geo-prefix could be stored in the mapping system.
A Geo-Prefix, when encoded in an EID-record, could be registered as an EID-prefix and when a Geo-Point is used as an EID lookup key, a sort of longest match could be looked up. If the Geo-Point is in the Circle described by the Geo-Prefix, an entry is returned to the Map-Requestor.
When a Geo-Point EID is looked up in the mapping system, what is returned is the longest prefix match. In this context, what is returned is the Geo-Prefix with the largest radius value, which corresponds to the largest physical area. If the Geo-Point supplied in a Map-Request has a mask-length/radius which is smaller than what is registered for any matching Geo-Prefix in the mapping system, then all Geo-Prefixes are returned. This uses the same overlapping lookup semantics defined in [RFC9301] for IP address EIDs.
You could take a combination of mappings from the above examples to ask the question: "Is the package in San Francisco"? This could be done with two lookups to the mapping system:

Contents of Mapping Database:
  EID=<dist-name="san francisco">
  RLOC=<geo-prefix-of-60-mile-radius-of-sf>

  EID=<ipv6-package-tracking-number>
  RLOC=<geo-point-of-current-location>

  EID=<geo-prefix-of-60-mile-radius-of-sf>
  RLOC=<dist-name="san francisco">

Map-Request for package:
  EID=<ipv6-package-tracking-number>
Mapping system returns:
  RLOC=<geo-point-of-current-location>

Map-Request for geo-point:
  EID=<geo-point-of-current-location>
Mapping system longest-match lookup returns:
  EID=<geo-prefix-of-60-mile-radius-of-sf>
  RLOC=<dist-name="san francisco">

If the package was not in San Francisco, the second mapping table lookup would fail.
Another application is concentric rings of WiFi access-points. The radius of each ring corresponds to the Wifi signal strength. An EID could be located in any of the inner rings but possibly on the edge of a ring. A WiFi access-point RLOC can be selected to encapsulate packets to because it will have better signal to the current EID location. And when there are intersecting circles, it can be determined that when the EID is in the intersection of the circles, it would be a good time to transition radios to closer APs or base stations.
When assigning EIDs to vehicles [I-D.jeong-its-v2i-problem-statement], a Geo-Prefix could be used to create a "reachability set" of Road-Side-Units (RSUs). So an ITR could encapsulate to multiple RLOCs in the Geo-Prefix to try to create connectivity to the vehicle while roaming. This makes use of predictive RLOCs [I-D.ietf-lisp-predictive-rlocs] that can be used when the direction of the roaming EID is known (a train track or single direction road, but not a flight path of a plane).

Geo-Prefix and Geo-Point Encodings
When a Geo-Prefix or a Geo-Point are encoded in an EID-record, it is encoded solely with the Geo-Location LCAF Type format when VPNs are not in use. When VPNs are used, the Geo-Location LCAF Type is encoded in the AFI field of the Instance-ID LCAF Type.
This document has no provision to validate the Geo-Location values.
The new Geo-Location format is:

  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |           AFI = 16387         |     Rsvd1     |     Flags     |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |   Type = 17   |     Rsvd2     |            Length             |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |U|N|E|A|M|R|K|    Reserved     |     Location Uncertainty      |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  Lat Degrees  |        Latitude Milliseconds                  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  Long Degrees |        Longitude Milliseconds                 |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                            Altitude                           |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |             Radius            |          Reserved             |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |              AFI              |         Address  ...          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

            Figure 1 - Geo-Location LCAF Encoding Format

AFI: Set to 16387 to indicate that the address is using the LCAF format from [RFC8060].
Type: 17 (suggested)
Rsvd1/Rsvd2/Flags: See [RFC8060] for details.
Length: length in bytes starting and including the byte after this Length field.
U-bit: If the U-bit is set, it indicates that the "Location Uncertainty" field is used. If the U-bit is clear, it indicates the "Location Uncertainty" field sent as 0 and ignored on receipt.
N-bit: If the N-bit is set, it indicates the Latitude is North relative to the Equator. If the N-bit is clear, it indicates the Latitude is South of the Equator.
E-bit: If the E-bit is set, it indicates the Longitude is East of the Prime Meridian. If the E-bit is clear, it indicates the Longitude is West of the Prime Meridian.
A-bit: If the A-bit is set, it indicates the "Altitude" field is used. If the A-bit is clear, it indicates the "Altitude" field is sent as 0 and ignored on receipt.
M-bit: If the M-bit is set, it indicates the "Altitude" is specified in meters. If the M-bit is clear, it indicates the "Altitude" is in centimeters.
R-bit: If the R-bit is set, it indicates the "Radius" field is used and the encoding is a Geo-Prefix. If the R-bit is clear, it indicates the "Radius" field is set to 0 and and the encoding is a Geo-Point.
K-bit: If the K-bit is set, it indicates the "Radius" is specified in kilometers. If the K-bit is clear, it indicates the "Radius" is in meters.
Reserved: These bits are reserved for future use for the addition of bit fields from the previous field. They MUST be set to 0 when sending protocol packets and MUST be ignored when receiving protocol packets.
Location Uncertainty: Unsigned 16-bit integer indicating the number of centimeters of uncertainty for the location.
Latitude Degrees: Unsigned 8-bit integer with a range of 0 - 90 degrees North or South of the Equator (northern or southern hemisphere, respectively).
Latitude Milliseconds: Unsigned 24-bit integer with a range of 0 - 3,599,999 (i.e., less than 60 minutes).
Longitude Degrees: Unsigned 8-bit integer with a range of 0 - 180 degrees east or west of the Prime Meridian.
Longitude Milliseconds: Unsigned 24-bit integer with a range of 0 - 3,599,999 (i.e., less than 60 minutes).
Altitude: Signed 32-bit integer containing the Height relative to sea level in centimeters or meters. A negative height indicates that the location is below sea level.
Radius: Unsigned 16-bit integer containing the radius of a circle (or sphere) centered at the specified coordinates. The radius is specified in meters unless the K-bit is specified indicating radius is in kilometers. When the radius is specified, this LCAF type encodes a Geo-Prefix where the Geo-Coordinates define the entire area of the circle defined by the radius and center point.
AFI/Address: The AFI field indicates the Address Family Identifier for the following address from from [AFI] and [RFC8060].

Backward Compatibility Considerations
EID-records encoded with the Geo-Location LCAF are supported only by LISP nodes that support them for registration and lookup purposes.
RLOC-records encoded with the Geo-Location LCAF can be returned from the mapping system lookups to LISP nodes that do not understand them. In such situations, the RLOC-record is ignored.

Security Considerations
The use of Geo-Coordinates in any application must be considered carefully to not violate any privacy concerns about physical location. This draft does take into consideration the applicability of BCP160 [RFC6280] for location-based privacy protection.
In a LISP environment, Geo-Coordinates can be registered to the Mapping Database System. When this occurs, an xTR is allowing its physical location to be known to queriers of the mapping system as well as network components that make up the mapping system. There are various sets of trust relationships that may exist.
An xTR at a LISP site already has a business and trust relationship with its Mapping Service Provider (MSP). When xTRs register their mappings with Geo-Coordinate information, a policy is agreed upon about who can access the information. Typically, the policy is stored locally and processed by the xTR when the MSP forwards Map-Requests to the xTRs of the LISP site. Conditionally, based on the requesting xTR, the responding xTR can apply the local policy to decide if a Map-Reply is sent with all RLOC-records, or perhaps, the RLOC-records that do not contain Geo-Coordinate information.
The MSP can also be requested by LISP site xTRs to proxy Map-Reply to Map-Requests. In this case, the MSP must apply the xTR policy so only authorized requesters get access to Geo-Coordinate information.
Note that once a requester is authorized, Map-Replies are returned directly to the requester and are signed with [RFC9303]. The Map-Replies not only authenticates the Map-Replier but can be encrypted by the Map-Replier so no eavesdropping of Geo-Coordinate information can occur.

Privacy Considerations
In addition to controlling where LISP Geo-Coordinate mapping records go and applying policies [Section 7] for who can access them, there are additional steps that can be taken to protect threats.
The suggestions from [RFC6973] can be implemented by existing LISP features, such as:
- Using signatures from [I-D.ietf-lisp-ecdsa-auth] can authenticate and authorize who can request such mapping records.
- Obfuscating a Geo-Point by using Geo-Prefixes instead uses data minimization techniques.
- Using short TTLs so the Geo-Coordinate mapping records are ephemeral reduces the attack window.
- Encrypting mapping records with either shared keys or using PKI [I-D.ietf-lisp-ecdsa-auth] so data is confidential both in transit to/from and at rest in the mapping system. Implementations exist which do encryption for various contract-tracing (virus-related) applications.
The typical applicability for the use of Geo-Coordinates will be to describe physical location for well known public structures, places, and landmarks versus people, vehicles, and equipment.

IANA Considerations
Following the guidelines of [RFC8126], IANA is asked to assign a value (17 is suggested) for the Geo-Coordinates LCAF from the "LISP Canonical Address Format (LCAF) Types" registry (defined in [RFC8060] as follows:

+=========+=====================+============================+
| Value # | LISP LCAF Type Name |         Reference          |
+=========+=====================+============================+
|   17    |   Geo-Location      | [This Document], Section 5 |
+---------+---------------------+----------------------------+

       Table 1: Geo-Location LCAF Type Assignment

Normative References
[GEO]

World Geodetic System 1984
Geodesy and Geophysics Department, DoD.
3 January 2000
NIMA TR8350.2

Informative References
[AFI]

Address Family Identifier (AFIs)
IANA
February 2007
ADDRESS FAMILY NUMBERS http://www.iana.org/assignments/address-family-numbers/address-family-numbers.xhtml?
[RFC8060]
[RFC9300]
[RFC1700]
[I-D.acee-ospf-geo-location]
[I-D.shen-isis-geo-coordinates]
[I-D.chen-idr-geo-coordinates]
[RFC9301]
[RFC2119]
[RFC8174]
[I-D.ietf-lisp-name-encoding]
[I-D.jeong-its-v2i-problem-statement]
[I-D.ietf-lisp-predictive-rlocs]
[RFC6280]
[RFC9303]
[RFC6973]
[I-D.ietf-lisp-ecdsa-auth]
[RFC8126]

Acknowledgments
The author would like to thank the LISP WG for their review and acceptance of this draft.
A special thanks goes to Enke Chen, Acee Lindem, and Naiming Shen for collaboarting on a consistent geo-location encoding format with OSPF [I-D.acee-ospf-geo-location], IS-IS [I-D.shen-isis-geo-coordinates], and BGP [I-D.chen-idr-geo-coordinates] protocols.

Document Change Log
[RFC Editor: Please delete this section on publication as RFC.]

Changes to draft-ietf-lisp-geo-08
- Posted July 2024.
- Made changes to reflect review by Kiran Makhijani.

Changes to draft-ietf-lisp-geo-07
- Posted June 2024.
- Made changes to reflect Rtgdir review by Ines Robles.

Changes to draft-ietf-lisp-geo-06
- Posted May 2024.
- Modify the abstract and change requesting 17 to suggesting type 17.

Changes to draft-ietf-lisp-geo-05
- Posted April 2024.
- Made more changes to allocate new type for the Geo-Coordinates LCAF.

Changes to draft-ietf-lisp-geo-04
- Posted April 2024.
- Make changes to reflect comments from Luigi which indicate to be more explicit about consitentcy of geo encodings with IGPs.
- Update document timer and references.

Changes to draft-ietf-lisp-geo-03
- Posted November 2023.
- Update document timer and references.

Changes to draft-ietf-lisp-geo-02
- Posted June 2023.
- Update document timer and references.

Changes to draft-ietf-lisp-geo-01
- Posted December 2022.
- Changes made to reflect comments from Luigi.

Changes to draft-ietf-lisp-geo-00
- Posted November 2022.
- Renamed draft-farinacci-lisp-geo-15 to make working group draft.

Changes to draft-farinacci-lisp-geo-15
- Posted November 2022.
- Made change to reflect last call comments. First sentence of intro and added a Privacy Considerations section.

Changes to draft-farinacci-lisp-geo-14
- Posted September 2022.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-13
- Posted March 2022.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-12
- Posted September 2021.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-11
- Posted March 2021.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-10
- Posted October 2020.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-09
- Posted April 2020.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-08
- Posted October 2019.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-07
- Posted April 2019.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-06
- Posted October 2018.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-05
- Posted April 2018.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-04
- Posted October 2017.
- Update document timer and references.

Changes to draft-farinacci-lisp-geo-03
- Posted April 2017.
- Update document timer.

Changes to draft-farinacci-lisp-geo-02
- Posted October 2016.
- Change format of the Geo-Coordinates LCAF Type to be compatible with equivalent proposals for OSPF, IS-IS, and BGP.
- Add to the Security Considerations section to BCP160 compliance.

Changes to draft-farinacci-lisp-geo-01
- Posted October 2016.
- Clarify that the Geo-Coordinates LCAF type should be encoded inside an Instance-ID LCAF type when VPNs are used.
- Indicate what the value of the Altitude field is when not included in a message. Since this draft shortens the field, a new value is specified in this draft for not conveying an Altitude value in a message.

Changes to draft-farinacci-lisp-geo-00
- Initial draft posted April 2016.